//SpaceTick
//Used for moving the targets.
if(!$AddedTargetCtrl)
{
 $SpaceMods::SpaceTick::Controllers = $SpaceMods::SpaceTick::Controllers TAB "TargetCtrl";
 $AddedTargetCtrl = 1;
}
if(!isObject(TargetCtrl))
{
 new SimSet(TargetCtrl){callFn = "targetCtrlTick";};
}

//Target Controller
function targetCtrlTick(%this)
{
 if(%this.lastSimTime == 0)
 {
  %lag = 10;
 }
 else
 {
  %lag = getSimTime() - %this.lastSimTime;
 }
 %this.lastSimTime = getSimTime();
 if($t){echo(%lag);}
 
 for(%i=0;%i<%this.getCount();%i+=1)
 {
  %obj=%this.getObject(%i);
  %pos = vectorAdd(%obj.getPosition(),%obj.speedVec);
  %obj.setTransform(vectorAdd(%obj.getPosition(),vectorScale(%obj.speedVec,(%lag/1000))) SPC %obj.rot);
  %obj.timer+=%lag;
  if(%obj.timer >= %obj.dieTime){%obj.delete();continue;}
 }
}

//OUTPUT: spawnShootTarget
//Spawns a shootable target above the brick, of the set type, facing the specified direction and up/down based on what is set. (Can't be hit if down)
registerOutputEvent(fxDTSBrick, spawnShootTarget, "list NONE 5 Target 0 Guy 1 Knight 2 Policeman 3 Pirate 4" TAB "list North 0 East 1 South 2 West 3" TAB "bool 0", 1);
function fxDTSBrick::spawnShootTarget(%brick,%type,%dir,%down,%client)
{
 switch(%type)
 {
  case 0:
   %target = ShootTarget;
   %skin = "";
  case 1:
   %target = ShootTargetM;
   %skin = "m1";
  case 2:
   %target = ShootTargetM;
   %skin = "m2";
  case 3:
   %target = ShootTargetM;
   %skin = "m3";
  case 4:
   %target = ShootTargetM;
   %skin = "base";
  case 5: //None
   if(isObject(%brick.shootTarget)){%brick.shootTarget.delete();}
   return;
 }
 %dir+=3;
 %dir = %dir % 4;
 switch(%dir)
 {
      case 0:
         %angularRotation = "1 0 0 0";
      case 1:
         %angularRotation = "0 0 1" SPC $piOver2;
      case 2:
         %angularRotation = "0 0 1" SPC $pi;
      case 3:
         %angularRotation = "0 0 -1" SPC $piOver2;
 }
 if(%down){%target = %target @ "Hit";}
 if(!isObject(%brick.shootTarget))
 {
  %brick.shootTarget = new StaticShape()
  {
   datablock = %target;
   spawnbrick = %brick;
  };missionCleanup.add(%brick.shootTarget);
 }
 else
 {
  %brick.shootTarget.setDatablock(%target);
 }
 %brick.shootTarget.setSkinName(%skin);
 %brick.shootTarget.setTransform(vectorAdd(vectorAdd(%brick.getWorldBoxCenter(),"0 0" SPC %brick.getDatablock().bricksizeZ*0.1),"0 0 0") SPC %angularRotation);
 %brick.shootTarget.isDead = %down;
}

//OUTPUT: spawnMovingTarget
//Spawns a moving, shootable target above the brick, of the set type, facing the specified direction and moving in the direction set. (Always 'falls' after shot, can't be hit again if shot) It lasts for the specified time in seconds. (max 5 per brick)
registerOutputEvent(fxDTSBrick, spawnMovingTarget, "list Target 0 Guy 1 Knight 2 Policeman 3 Pirate 4" TAB "list North 0 East 1 South 2 West 3" TAB "vector" TAB "int 1 10 3", 1);
function fxDTSBrick::spawnMovingTarget(%brick,%type,%dir,%vector,%time,%client)
{
 for(%i=0;isObject(%brick.shootMoveTarget[%i]);%i++){}
 if(%i > 4){return;}
 switch(%type)
 {
  case 0:
   %target = ShootTarget;
   %skin = "";
  case 1:
   %target = ShootTargetM;
   %skin = "m1";
  case 2:
   %target = ShootTargetM;
   %skin = "m2";
  case 3:
   %target = ShootTargetM;
   %skin = "m3";
  case 4:
   %target = ShootTargetM;
   %skin = "base";
 }
 %dir+=3;
 %dir = %dir % 4;
 switch(%dir)
 {
      case 0:
         %angularRotation = "1 0 0 0";
      case 1:
         %angularRotation = "0 0 1" SPC $piOver2;
      case 2:
         %angularRotation = "0 0 1" SPC $pi;
      case 3:
         %angularRotation = "0 0 -1" SPC $piOver2;
 }
 %brick.shootMoveTarget[%i] = new StaticShape()
 {
  datablock = %target;
  spawnbrick = %brick;
 };missionCleanup.add(%brick.shootMoveTarget[%i]);
 %pos = vectorAdd(vectorAdd(%brick.getWorldBoxCenter(),"0 0" SPC %brick.getDatablock().bricksizeZ*0.1),"0 0 0");
 %brick.shootMoveTarget[%i].setTransform(%pos SPC %angularRotation);
 %brick.shootMoveTarget[%i].isDead = 0;
 %brick.shootMoveTarget[%i].setSkinname(%skin);
 if(vectorLen(%vector) > 20) //can't go more than 20 speed
 {
  %vector = vectorScale(vectorNormalize(%vector),20);
 }
 %brick.shootMoveTarget[%i].speedVec = %vector;
 %brick.shootMoveTarget[%i].dieTime = %time*1000;
 %brick.shootMoveTarget[%i].rot = %angularRotation;
 %brick.shootMoveTarget[%i].isMoving = 1;
 TargetCtrl.add(%brick.shootMoveTarget[%i]);
}

//INPUT: onTargetProjectileHit
//When someone shoots the brick's target or a moving target spawned by it (The code for this is in the package below!)
registerInputEvent(fxDTSBrick, onTargetProjectileHit, "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Projectile Projectile" TAB "MiniGame MiniGame");

//Datablocks
//In the tutorial these are named "TutorialTarget" etc. but I don't want to overwrite datablocks
datablock StaticShapeData(ShootTarget)
{
	shapeFile = "Add-Ons/Map_Tutorial/target.dts";
};
datablock StaticShapeData(ShootTargetHit)
{
	shapeFile = "Add-Ons/Map_Tutorial/targetHit.dts";
};
datablock StaticShapeData(ShootTargetM)
{
	shapeFile = "Add-Ons/Map_Tutorial/targetM.dts";
};
datablock StaticShapeData(ShootTargetMHit)
{
	shapeFile = "Add-Ons/Map_Tutorial/targetMHit.dts";
};

//Package
//Lets you shoot targets
package EventTargets
{
   function ProjectileData::OnCollision(%this,%obj,%col,%pos,%norm,%fade,%vel)
   {
    Parent::OnCollision(%this,%obj,%col,%pos,%norm,%fade,%vel);
    if(%col.getClassName() $= "StaticShape" && (%col.getDatablock().getName() $= "ShootTarget" || %col.getDatablock().getName() $= "ShootTargetM") && !%col.isDead)
    {
     if(isObject(%col.spawnbrick.getGroup().client) && %col.spawnbrick.getGroup().client.minigame != %obj.client.minigame){return;}
     serverplay3d(hammerhitsound,%col.getTransform());
     if(%col.isMoving)
     {
      %col.isDead = 1;
      %col.setDatablock(%col.getDatablock().getName() @ "Hit");
     }
     $InputTarget_["Self"]   = %col.spawnbrick;
     $InputTarget_["Player"] = %obj.client.player;
     $InputTarget_["Client"] = %obj.client;
     $InputTarget_["Projectile"] = %obj;
     if($Server::LAN)
     {
        $InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
     }
     else
     {
        $InputTarget_["MiniGame"] = getMiniGameFromObject(%col.spawnbrick);
     }
     %col.spawnbrick.processInputEvent("onTargetProjectileHit", %obj.client);
    }
   }
   function fxDTSBrick::killBrick(%brick)
   {
    if(isObject(%brick.shootTarget)){%brick.shootTarget.delete();}
    for(%i=0;%i<5;%i+=1)
    {
     if(isObject(%brick.shootMoveTarget[%i])){%brick.shootMoveTarget[%i].delete();}
    }
    Parent::killBrick(%brick);
   }
   function fxDTSBrick::delete(%brick)
   {
    if(isObject(%brick.shootTarget)){%brick.shootTarget.delete();}
    for(%i=0;%i<5;%i+=1)
    {
     if(isObject(%brick.shootMoveTarget[%i])){%brick.shootMoveTarget[%i].delete();}
    }
    Parent::delete(%brick);
   }
};activatePackage(EventTargets);
